%Load dataset containing growth, death and recovery rates for all 
%training and validation experiments
%estimated with either linear regression (datasetsB_all)
%or the logistic method (datasets_Frederic_all)

%datasetsB_all
datasets_Frederic_all
FFNN_g_reg %run the ANN model that descriminates between growth and recovery experiments
clear

%datasetsB_all
datasets_Frederic_all
FFNN_gr_d %run the ANN model that descriminates between growth and death experiments
clear

datasets_Frederic_all
%datasetsB_all
FFNN_reg_d %run the ANN model that descriminates between recovery and death experiments

clear
datasets_Frederic_all

%load the ANN results to do the analysis
%Estimate averages and STDs for the training cases over all runs for all three models

load Mt_grd;
Mtg1 = Mtg;
Mtd1 = Mtd;
Mtrg11 = Mtrg
Mtgs1 = Mtg2;
Mtds1 = Mtd2;
Mtrgs11 = Mtrg2;
rgc11 = rgc;
gc1 = gc;
dc1 = dc;
Mt_grd = Mt;
Tp_grd = Train_scores_av;
Ta_grd = T;
max(max(Tp_grd))
MeanInputWB_grd = InputWB/max_runs;
STDInputWB_grd = InputWB2/max_runs -MeanInputWB_grd.^2;
MeanHidenWB_grd = HidenWB/max_runs;
STDHidenWB_grd = HidenWB2/max_runs -MeanHidenWB_grd.^2;


load Mt_grg;
Mtgs2 = Mtg2;
Mtg2 = Mtg;
Mtrg1 = Mtrg;
Mtrgs1 = Mtrg2;
Mtd11 = Mtd;
Mtds11 = Mtd2;
dc11 = dc;
gc2 = gc;
rgc1 =rgc; 
Mt_grg = Mt;
Tp_grg = Train_scores_av;
Ta_grg = T;
max(max(Tp_grg))
MeanInputWB_grg = InputWB/max_runs;
STDInputWB_grg = InputWB2/max_runs -MeanInputWB_grg.^2;
MeanHidenWB_grg = HidenWB/max_runs;
STDHidenWB_grg = HidenWB2/max_runs -MeanHidenWB_grg.^2;

load Mt_rd;
Mtrgs2 = Mtrg2;
Mtrg2 = Mtrg;
Mtds2 = Mtd2;
Mtd2 = Mtd;
Mtg11 = Mtg;
Mtgs11 = Mtg2;
gc11 = gc;
rgc2 = rgc;
dc2 = dc;
Mt_rd = Mt;
Tp_rd = Train_scores_av;
Ta_rd = T;
max(max(Tp_rd))
MeanInputWB_rd = InputWB/max_runs;
STDInputWB_rd = InputWB2/max_runs -MeanInputWB_rd.^2;
MeanHidenWB_rd = HidenWB/max_runs;
STDHidenWB_rd = HidenWB2/max_runs -MeanHidenWB_rd.^2;

% Separate the death, growth and recovery experiments to estimate the correlation coefficients

Ta = [Ta_grd Ta_grg Ta_rd];
kd = 0;
kg = 0;
krg = 0;
D_ind = [];
RG_ind = [];
G_ind = [];
for i=1:length(Ta);
    if (Ta(1,i) < 0 & Ta(2,i) < 0)
        kd = kd +1;
        D_ind(kd) = i;
    end
    if (Ta(1,i) < 0 & Ta(2,i) > 0)
        krg = krg +1;
        RG_ind(krg) = i;
    end
    if (Ta(1,i) > 0 & Ta(2,i) > 0)
        kg = kg +1;
        G_ind(kg) = i;
    end 
end    

Tp = [Tp_grd Tp_grg Tp_rd];
Temp = [Teg Ted Teg Terg Terg Ted];
Temp = [Temp' Temp']';
Ph = [Phg Phd Phg Phrg Phrg Phd];
Ph = [Ph' Ph']';
Na = [Nag Nad Nag Narg Narg Nad];
Na = [Na' Na']';

%Estimate the correlation coefficient for the training data
Ctrain = corrcoef(Ta, Tp)

% Generate figures for the training data
figure(2)
plot(Ta(1,D_ind),Tp(1,D_ind),'k+')
hold on
plot(Ta(1,G_ind),Tp(1,G_ind),'g*')
plot(Ta(1,RG_ind),Tp(1,RG_ind),'ro')
legend('death','growth','regrowth, Combined r^2 = ')
plot(Ta(2,D_ind),Tp(2,D_ind),'k+')
hold on
plot(Ta(2,G_ind),Tp(2,G_ind),'g*')
plot(Ta(2,RG_ind),Tp(2,RG_ind),'ro')
xlabel('Observed mmax values')
ylabel('Predicted mmax values')
title('Observed vs Predicted mmax values using NNs on fermentations used for training')

figure(3)
plot(Temp,Tp,'+')
xlabel('Observed Temp values')
ylabel('Predicted mmax values')
title('Temperature vs mmax values using NNs on fermentations used for training')

figure(4)
plot(Ph,Tp,'+')
xlabel('Observed Ph values')
ylabel('Predicted mmax values')
title('Ph vs mmax values using NNs on fermentations used for training')

figure(5)
plot(Na,Tp,'+')
xlabel('Observed Na values')
ylabel('Predicted mmax values')
title('Na vs mmax values using NNs on fermentations used for training')

figure(6)
plot3(Temp(1,G_ind),Na(1,G_ind),Tp(1,G_ind),'g*')
hold on
plot3(Temp(1,RG_ind),Na(1,RG_ind),Tp(1,RG_ind),'ro')
hold on
plot3(Temp(1,D_ind),Na(1,D_ind),Tp(1,D_ind),'k+')
legend('growth','regrowth','death')
plot3(Temp(2,G_ind),Na(2,G_ind),Tp(2,G_ind),'g*')
hold on
plot3(Temp(2,RG_ind),Na(2,RG_ind),Tp(2,RG_ind),'ro')
hold on
plot3(Temp(2,D_ind),Na(2,D_ind),Tp(2,D_ind),'k+')
grid
xlabel('Observed Temperature values')
ylabel('Observed NaCl values')
zlabel('Predicted mmax values')
title('Mmax values using NNs on fermentations used for training')

%Estimate the number of votes provided by the 3 ANN models for each growth condition
%i.e. the total number of predicted growth (gc), death (dc) and recovery (rgc) experiments
%over all 500 runs, for each of the validation experiments

gc = gc1+gc2; 
dc = dc1+dc2;
rgc = rgc1+rgc2;

L2 = Lt2;
Mv = zeros(L2,2);
Mvs = zeros(L2,2);
Svs = zeros(L2,2);
m1 = 0;
m2 = 0;
m3 = 0; 

%Estimate the average predicted growth rate for each of the validation experiment
%provided by the ANN models. For each growth rate, only the two ANN models that
%have been train to discriminate this growth condition are used

for i=1:L2

vote = [gc(i) dc(i) rgc(i)]; %record the number of votes
[val,I] = max(vote); %select the condition that has been voted most of the times as the most likely

if (I==1) %prediction: growth
    %choose set with minimum variance 
        Mtg1_std = mean(Mtgs1(i,:)/gc1(i)-(Mtg1(i,:)/gc1(i)).^2);
	Mtg2_std = mean(Mtgs2(i,:)/gc2(i)-(Mtg2(i,:)/gc2(i)).^2);
	stds = [Mtg1_std Mtg2_std];
	[ms,J] = min(stds);
	if (J==1) %first ANN model for growth
	      m1 = m1 +1
	      Mvs(i,:) = Mtg1(i,:)/gc1(i);
              Svs(i,1) = ms;  
              
	elseif (J==2) %second ANN model for growth
	      m2 = m2 +1
    	      Mvs(i,:) = Mtg2(i,:)/gc2(i);
              Svs(i,1) = ms;
           
        end      
        %also estimate the average of two nets that learn growth 
        Mv(i,:) = (Mtg1(i,:)/gc1(i) + Mtg2(i,:)/gc2(i))/2;
  
  elseif(I==2) %prediction: death
	Mtd1_std = mean(Mtds1(i,:)/dc1(i)-(Mtd1(i,:)/dc1(i)).^2);
	Mtd2_std = mean(Mtds2(i,:)/dc2(i)-(Mtd2(i,:)/dc2(i)).^2);
	stds = [Mtd1_std Mtd2_std];
	[ms,J] = min(stds);
	if (J==1)  %first ANN model for death
	        m2 = m2 + 1
		Mvs(i,:) = Mtd1(i,:)/dc1(i);
        	Svs(i,1) = ms; 
	elseif (J==2) %second ANN model for death
	        m3 = m3 +1
	        Mvs(i,:) = Mtd2(i,:)/dc2(i);
                Svs(i,1) = ms;               
        end  
       %also estimate the average of two nets that learn death 
       Mv(i,:) = (Mtd1(i,:)/dc1(i) + Mtd2(i,:)/dc2(i))/2;   
  
  elseif(I==3) %prediction: recovery
	Mtrg1_std = Mtrgs1(i,:)/rgc1(i)-(Mtrg1(i,:)/rgc1(i)).^2;
	Mtrg2_std = Mtrgs2(i,:)/rgc2(i)-(Mtrg2(i,:)/rgc2(i)).^2;
	stds = [mean(Mtrg1_std) mean(Mtrg2_std)];
	[ms,J] = min(stds);
	if (J==1) %first ANN model for recovery
	        m1 = m1 +1
		Mvs(i,:) = Mtrg1(i,:)/rgc1(i);
                Svs(i,:) = Mtrg1_std;
	elseif (J==2) %second ANN model for recovery     
	        mm3 = m3 + 1 
	        Mvs(i,:) = Mtrg2(i,:)/rgc2(i);
                Svs(i,:) = Mtrg2_std ; 
        end 
        %also estimate the average of two nets that learn recovery 
        Mv(i,:) = (Mtrg1(i,:)/rgc1(i) + Mtrg2(i,:)/rgc2(i))/2;
  end

end

%Mvv = (Mv(:,1)+Mv(:,2))/2;
%Mvvs = (Mvs(:,1)+Mvs(:,2))/2;
%M = Mt_rd + Mt_grg + Mt_grd;
%M = M/3;
%Mo = (M(:,1)+M(:,2))/2

%print predicted means and stds
Mvs
Svs

%C1=corrcoef(M,Tt2);
%C2 = corrcoef(Mv,Tt2);
%C3 = corrcoef(Mvs,Tt2);
%C11 = C1(1,2)^2
%C22 = C2(1,2)^2
%C33 = C3(1,2)^2

figure(7)
plot(Tt2(1,1),Mvs(1,1),'ks')
hold on
plot(Tt2(2,1),Mvs(2,1),'rs')
plot(Tt2(3,1),Mvs(3,1),'gs')
legend('death','regrowth','growth')
plot(Tt2(2,2),Mvs(2,2),'ro')
axis([-0.5 0.5 -0.5 0.5])
x = [-0.5:0.01:0.5];
plot(x,x,'--')
xlabel('Observed mmax values')
ylabel('Predicted mmax values')
title('Observed vs Predicted mmax values using NNs on 3 test fermentations')


%combine all experiments to estimate correlations
Tall = [Tp Mvs'];
Tacll = [Ta Tt2'];
Tallb = [Tall(1,:) Tall(2,:)];
Tacllb = [Tacll(1,:) Tacll(2,:)];

%Take correlations (R^2) for training, validation, and all experiments 
Train_r = corrcoef(Ta,Tp).^2
Validate_r = corrcoef(Mvs,Tt2).^2
comb_r = corrcoef(Tallb,Tacllb).^2
comb_r_sqrt = corrcoef(sqrt(abs(Tallb)),sqrt(abs(Tacllb))).^2



figure(8)
plot(Ta(1,D_ind),Tp(1,D_ind),'k+')
hold on
plot(Ta(1,G_ind),Tp(1,G_ind),'g*')
plot(Ta(1,RG_ind),Tp(1,RG_ind),'ro')
legend('death','growth','regrowth, Combined r^2 = ')
plot(Ta(2,D_ind),Tp(2,D_ind),'k+')
hold on
plot(Ta(2,G_ind),Tp(2,G_ind),'g*')
plot(Ta(2,RG_ind),Tp(2,RG_ind),'ro')
errorbar(Tt2(1,1),(Mvs(1,1)+Mvs(1,2))/2,Svs(1,1),'ks')
errorbar(Tt2(2,1),Mvs(2,1),Svs(2,1),'rs')
errorbar(Tt2(3,1),(Mvs(3,1)+Mvs(3,2))/2,Svs(3,1),'gs')
errorbar(Tt2(2,2),Mvs(2,2),Svs(2,2),'rs')
errorbar(Tt2(4,1),(Mvs(4,1)+Mvs(4,2))/2,Svs(4,1),'gs')

axis([-0.6 2 -0.6 2])
x = [-0.6:0.01:2];
plot(x,x,'--')
xlabel('Observed mmax values')
ylabel('Predicted mmax values')
title('Observed vs Predicted mmax values using NNs (test fermentations shown in squares)')

k=0;
for i=1:10
  for j=1:4
  k=k+1;
  figure(9)
  hold on
  errorbar(k,MeanInputWB_grd(i,j),STDInputWB_grd(i,j)/sqrt(max_runs),'ks')
  
  figure(10)
  hold on
  errorbar(k,MeanInputWB_rd(i,j),STDInputWB_rd(i,j)/sqrt(max_runs),'ks')
  
  figure(11)
  hold on
   errorbar(k,MeanInputWB_grg(i,j),STDInputWB_grg(i,j)/sqrt(max_runs),'ks')
  end
end

for i=1:2
  for j=1:11
  k=k+1;
  figure(9)
  if(i==1)
   errorbar(k,MeanHidenWB_grd(i,j),STDHidenWB_grd(i,j)/sqrt(max_runs),'ko')
  end
  
  figure(10)
  errorbar(k,MeanHidenWB_rd(i,j),STDHidenWB_rd(i,j)/sqrt(max_runs),'ko')
  
  figure(11)
   errorbar(k,MeanHidenWB_grg(i,j),STDHidenWB_grg(i,j)/sqrt(max_runs),'ko')
  end
end



