datasetskB_Fred_all %load dataset with kB values

FFNN_g_d   %run the ANN to discriminate between bacteriocin production vs. no production

load M_gd; %load ANN results and do the analysis
Mtg1 = Mtg;
Mtd1 = Mtd;
Mtgs1 = Mtg2;
Mtds1 = Mtd2;
Mt_grd = Mt;
Tp = Train_scores_av;
Ta = T;
max(max(Tp))
%I = find(Tp < 0.2);
%Tp(I)=0;

%Estimate averages and STD over all runs

MeanInputWB = InputWB/max_runs;
STDInputWB = InputWB2/max_runs -MeanInputWB.^2;
MeanHidenWB = HidenWB/max_runs;
STDHidenWB = HidenWB2/max_runs -MeanHidenWB.^2;

%Estimate the correlation coefficient for the training set
Ctrain = corrcoef(Ta, Tp)

Temp = [Teg Ted]; 
Ph = [Phg Phd]; 
Na = [Nag Nad]; 

%Generate figures
figure(2)
hold on
plot(Ta(1:16),Tp(1:16),'g*')
plot(Ta(17:36),Tp(17:36),'k+')
legend('kB production','no kB production, Combined r^2 = ')
xlabel('Observed kB values')
ylabel('Predicted kB values')
title('Observed vs Predicted mmax values using NNs on fermentations used for training')

figure(3)
plot(Temp,Tp,'+')
xlabel('Observed Temp values')
ylabel('Predicted kB values')
title('Temperature vs mmax values using NNs on fermentations used for training')

figure(4)
plot(Ph,Tp,'+')
xlabel('Observed Ph values')
ylabel('Predicted kB values')
title('Ph vs mmax values using NNs on fermentations used for training')

figure(5)
plot(Na,Tp,'+')
xlabel('Observed Na values')
ylabel('Predicted kB values')
title('Na vs kB values using NNs on fermentations used for training')

figure(6)
plot3(Teg,Nag,Tp(1:16),'g*')
hold on
plot3(Ted,Nad,Tp(17:36),'k+')
legend('kB production','no kB production')
grid
xlabel('Observed Temperature values')
ylabel('Observed NaCl values')
zlabel('Predicted kB values')
title('Mmax values using NNs on fermentations used for training')


%Estimate predicted values for the validation cases
L2 = Lt2;
Mv = zeros(L2,1);
Mvs = zeros(L2,1);
Svs = zeros(L2,1);

for i=1:L2


vote = [gc(i) dc(i)];
[val,I] = max(vote);

if (I==1)
    Mvs(i) = Mtg1(i)/gc(i);
    Svs(i) = Mtgs1(i)/gc(i)-(Mtg1(i)/gc(i)).^2;  
elseif(I==2)
    Mvs(i,:) = Mtd1(i)/dc(i);
    Svs(i,1) =  Mtds1(i)/dc(i)-(Mtd1(i)/dc(i)).^2;	
end

end

Mvs
Svs

%Estimate the correlation coefficient for the validation cases
C1 = corrcoef(Mvs,Tt2);
C11 = C1(1,2)^2 %This is R^2

%Generate figures for the validation cases
figure(7)
plot(Tt2(1),Mvs(1),'ks')
hold on
plot(Tt2(2:4),Mvs(2:4),'gs')
legend('no kB production','kB production')
axis([-20 0 -20 0])
x = [-20:1:0];
plot(x,x,'--')
xlabel('Observed kB values')
ylabel('Predicted kB values')
title('Observed vs Predicted kB values using NNs on 4 test fermentations')


%Generate figures for both training and validation results

Tall = [Tp Mvs'];
Tacll = [Ta Tt2'];
comb_r = corrcoef(Tall,Tacll).^2
comb_r_sqrt = corrcoef(sqrt(abs(Tall)),sqrt(abs(Tacll))).^2

Ta = Ta*Maxv;
Tp = Tp*Maxv;
Mvs = Mvs*Maxv;
Tt2 = Tt2*Maxv;
Tall = [Tp Mvs'];
Tacll = [Ta Tt2'];

figure(9)
hold on
plot(Ta(1:16),Tp(1:16),'g*')
plot(Ta(17:36),Tp(17:36),'k+')
legend('kB production','no kB production, Combined r^2 = ')
plot(Tt2(1),Mvs(1),'ks')
plot(Tt2(2:4),Mvs(2:4),'gs')
errorbar(Tt2(1),Mvs(1),Svs(1),'ks')
errorbar(Tt2(2:4),Mvs(2:4),Svs(2:4),'gs')


axis([0 3e-06 0 3e-06])
x = [0:1e-07:3e-06];
plot(x,x,'--')
xlabel('Observed kB values')
ylabel('Predicted kB values')
title('Observed vs Predicted kB values using NNs (test fermentations shown in squares)')

Ta = sqrt(Ta);
Tp = sqrt(Tp)
Mvs = sqrt(Mvs)
Tt2 = sqrt(Tt2);
Tall = [Tp Mvs'];
Tacll = [Ta Tt2'];
comb_r = corrcoef(Tall,Tacll).^2

figure(10)
hold on
plot(Ta(1:16),Tp(1:16),'g*')
plot(Ta(17:36),Tp(17:36),'k+')
legend('Production','No production, Combined r^2 = ')
plot(Tt2(1),Mvs(1),'ks')
plot(Tt2(2:4),Mvs(2:4),'gs')
axis([0 1.8e-03 0 1.8e-03])
x = [0:1e-04:1.8e-03];
plot(x,x,'--')
xlabel('Observed sqrt(kB) values')
ylabel('Predicted sqrt(kB) values')
title('Observed vs Predicted sqrt(kB) values using NNs (test fermentations shown in squares)')


k=0;
for i=1:10
  for j=1:4
  k=k+1;
  figure(11)
  hold on
    errorbar(k,MeanInputWB(i,j),STDInputWB(i,j)/sqrt(max_runs),'ks') 
  end
end

for i=1:11
  k=k+1;
  figure(11)
   errorbar(k,MeanHidenWB(i),STDHidenWB(i)/sqrt(max_runs),'ko')

end