% Use a feed-forward neural network for the growth curves

Teo = [Teg Terg];
Pho = [Phg Phrg];
Nao = [Nag Narg];

To = [Tg Trg];
T=To;

Te = 0.8*((Teo - min(Teb))./(max(Teb)-min(Teb)))+0.1;
Ph = 0.8*((Pho - min(Phb))./(max(Phb)-min(Phb)))+0.1;
Na = 0.8*((Nao - min(Nab))./(max(Nab)-min(Nab)))+0.1;
P = [Te;Ph;Na];

L = length(T);
A1 = std(Tg');
A2 = std(Trg');
Lg = length(Tg);
Lrg = length(Trg);

%Tolerance for errors in Time of Max growth, Max growth, Final Population
Tol = [0.05*ones(L,1) 0.05*ones(L,1)]';
%0.05*ones(L,1)]';

Prog_scoresB = [];
max_times= 1;
Train_scores = [];
Train_scores_av = zeros(2,L);
InputWB=zeros(10,4);
HidenWB=zeros(2,11);
InputWB2=zeros(10,4);
HidenWB2=zeros(2,11);

for runs = 1:max_runs

%    Tg = Tg + (randn(Lg,1)*A1/10)';
 %   Trg = Trg + (randn(Lrg,1)*A2/10)';
  %  T = [Tg Trg];
	%Train_scores = [];
	Test_scores = [];
	Prog_scores = [];


	for times = 1:max_times
  
		r = randperm(L)
		Train_data = P(:,r);
		Train_targetC = T(:,r);
		N1 = length(Train_data);

%Create a feed forward network with three input, 10 hidden and 1 output
%neuron
%net = newelm([0 1; 0 1; 0 1],[10 1],{'logsig' 'purelin'},'trainlm', 'learngdm', 'mse');
%[NET,tr,Y,E] = train(net,Train_data,Train_targetC,[],[],[],TV);

		net = newff([0 1; 0 1; 0 1;],[10 2],{'logsig' 'purelin'},'trainlm', 'learngdm', 'mse');
                %net = newff([0 1; 0 1; 0 1;],[10 2],{'tansig' 'purelin'},'trainlm', 'learngdm', 'mse');

		y1 = sim(net,Train_data);

		net.trainParam.epochs = 1000;
		net.trainParam.goal = 0.00000001;
		net.trainParam.mingrad = 1e-25;
		net.trainParam.mu_max = 1e25;
		
		[NET,tr,Y,E] = train(net,Train_data,Train_targetC,[],[],[],[]);

		y2=sim(NET,Train_data);
       	        y4=sim(NET,xt2);
       	        
 		InputWB = InputWB + [NET.IW{1} NET.b{1}];
 		HidenWB = HidenWB + [NET.LW{2} NET.b{2}];
 		InputWB2 = InputWB2 + [NET.IW{1} NET.b{1}].^2;
		HidenWB2 = HidenWB2 + [NET.LW{2} NET.b{2}].^2;
 			
		%Test_scores = [Test_scores' y3 Test_targetC]';
		Train_scores = [Train_scores y2' Train_targetC'];
                Train_scores_av(:,r) = Train_scores_av(:,r) + y2; 
		Prog_scores = [Prog_scores' y4]';

%Train_error(times) = length(find(abs(y2-Train_targetC) > 0.05 ));
%Test_error(times) = length(find(abs(y3-Test_targetC) > 0.05));
%[y4' Tt2']

end


%SEP = (100/mean(Ya))*sqrt((Yn-Ya)'*(Yn-Ya)/N
%Take mean of predictions over CV runs

L2 = length(Tt2);
M = zeros(L2,2);
for i=1:max_times
 k = Prog_scores(1+(i-1)*L2:L2*i,:);
 M = M+k;
end
M = M/max_times;

Prog_scoresB = [Prog_scoresB' M]';

end

%Take mean of predictions over 20x18 CV runs

Prog_scoresB = Prog_scoresB';
Mt = zeros(L2,2);
Mtg = zeros(L2,2);
Mtrg = zeros(L2,2);
Mtg2 = zeros(L2,2);
Mtrg2 = zeros(L2,2);
Mtd = zeros(L2,2);
Mtd2 = zeros(L2,2);

gc = zeros(L2,1);
rgc = zeros(L2,1);
dc = zeros(L2,1);

for i=1:max_runs
 k = Prog_scoresB(:,1+(i-1)*2:2*i);
 for j=1:L2
   if (k(j,1) > 0) & (k(j,2) > 0)
      gc(j) = gc(j) + 1;
      Mtg(j,:) = Mtg(j,:) + k(j,:);
      Mtg2(j,:) = Mtg2(j,:) + k(j,:).^2;
   elseif (k(j,1) < 0) & (k(j,2) > 0)
      rgc(j) = rgc(j) + 1;
      Mtrg(j,:) = Mtrg(j,:)+ k(j,:);
      Mtrg2(j,:) = Mtrg2(j,:) + k(j,:).^2;
   elseif (k(j,1) < 0) & (k(j,2) < 0)
      dc(j) = dc(j) + 1;
      Mtd(j,:) = Mtd(j,:)+ k(j,:);
      Mtd2(j,:) = Mtd2(j,:) + k(j,:).^2;   
   end  
 end 
 Mt = Mt+k;
end
Mt = Mt/max_runs

%Mtg = [Mtg(:,1)./gc Mtg(:,2)./gc]/max_runs
%Mtrg =[Mtrg(:,1)./rgc Mtrg(:,2)./rgc]/max_runs 


%C = corrcoef(Mt, Tt2);
%Corr = C(1,2)^2

Train_scores_av = Train_scores_av/max_runs

save Mt_grg Mt Mtg Mtrg Mtd Mtg2 Mtrg2 Mtd2 Train_scores T Train_scores_av gc dc rgc InputWB HidenWB InputWB2 HidenWB2