% Use a feed-forward neural network for the growth curves

To = [Tg Td];
T = To;

Teo = [Teg Ted];
Pho = [Phg Phd];
Nao = [Nag Nad];

Te = 0.8*((Teo - min(Teb))./(max(Teb)-min(Teb)))+0.1;
Ph = 0.8*((Pho - min(Phb))./(max(Phb)-min(Phb)))+0.1;
Na = 0.8*((Nao - min(Nab))./(max(Nab)-min(Nab)))+0.1;

P = [Te;Ph;Na];
L = length(T);
A1 = std(Tg');
A2 = std(Td');
Lg = length(Tg);
Ld = length(Td);

%Tolerance for errors in Time of Max growth, Max growth, Final Population
Tol = [0.05*ones(L,1) 0.05*ones(L,1)]';
%0.05*ones(L,1)]';

%Data = load('Luc1_data.txt');
%P = Data(:,1:2);
%Te = P(:,1)';
%Ph = P(:,2)';
%Te= 0.8*((Te - min(Te))./(max(Te)-min(Te)))+0.1;
%Ph = 0.8*((Ph - min(Ph))./(max(Ph)-min(Ph)))+0.1;
%P = [Te(1:11);Ph(1:11);];

%T = Data(1:11,3:4)';
%xt2 = [Te(12:13);Ph(12:13);];
%Tt2 = Data (12:13,3:4)';

Prog_scoresB = [];
max_times= 1;
Train_scores = [];
Train_scores_av = zeros(2,L);

InputWB=zeros(10,4);
HidenWB=zeros(1,11);
InputWB2=zeros(10,4);
HidenWB2=zeros(1,11);


for runs = 1:max_runs

   % Tg = Tg + (randn(Lg,1)*A1/10)';
   % Td = Td + (randn(Ld,1)*A2/10)';
   % T = [Tg Td];
 
	%Train_scores = [];
	Test_scores = [];
	Prog_scores = [];


	for times = 1:max_times
    
		%Test_data = P(:,times);
		%Test_targetC = T(:,times);
		
		r = randperm(L)
		%P = P(:,r);
		%T = T(:,r);
		
		Train_data = P(:,r);
		%Train_data(:,times) = [];
		Train_targetC = T(:,r);
		%Train_targetC(:,times) = [];

%L1 = 16;
%L2 = 10;
%L1 = 4;
%L2 = 3;
%r1 = randperm(L1);
%r2 = L1+randperm(L1);
%rtr = [r1(1:L2) r2(1:L2)];
%rts = [r1(L2+1:L1) r2(L2+1:L1)];

%r = randperm(18);
%r=[1:18];
%rtr = r(1:10);
%rts = r(11:18);

%Train_data = P(:,rtr);
%Train_targetC = T(:,rtr);

%Test_data = P(:,rts);
%Test_targetC = T(:,rts);

		N1 = length(Train_data);
		%N2 = length(Test_data);

%TV.P = Test_data;
%TV.T = Test_targetC;

%Create a feed forward network with three input, 10 hidden and 1 output
%neuron

%net = newff([0 1; 0 1; 0 1;],[10 1],{'tansig' 'purelin'},'trainlm', 'learngdm', 'mse');
net = newff([0 1; 0 1; 0 1;],[10 1],{'logsig' 'purelin'},'trainlm', 'learngdm', 'mse');

%net = newelm([0 1; 0 1; 0 1],[3 1],{'logsig' 'purelin'},'trainlm', 'learngdm', 'mse');

		y1 = sim(net,Train_data);

		net.trainParam.epochs = 1000;
		net.trainParam.goal = 0.00000001;
		net.trainParam.mingrad = 1e-25;	
		net.trainParam.mu_max = 1e25;
		
%[NET,tr,Y,E] = train(net,Train_data,Train_targetC,[],[],[],TV);
		[NET,tr,Y,E] = train(net,Train_data,Train_targetC(1,:),[],[],[],[]);

		y2=sim(NET,Train_data);
        y2 = [y2' y2']';
		%y3=sim(NET,Test_data);
		y4=sim(NET,xt2);
        y4 = [y4' y4']';
		%y4(1,:) = (max(To(1,:))-min(To(1,:)))*(y4(1,:)-0.1)/0.8 + min(To(1,:));	
		%y4(2,:) = (max(To(2,:))-min(To(2,:)))*(y4(2,:)-0.1)/0.8 + min(To(2,:));	
                InputWB = InputWB + [NET.IW{1} NET.b{1}];
 		HidenWB = HidenWB + [NET.LW{2} NET.b{2}];
 		InputWB2 = InputWB2 + [NET.IW{1} NET.b{1}].^2;
		HidenWB2 = HidenWB2 + [NET.LW{2} NET.b{2}].^2;
 		
                 
		%Test_scores = [Test_scores' y3 Test_targetC]';
		%Train_scores = [Train_scores abs(y2-Train_targetC)'];
        Train_scores = [Train_scores y2' Train_targetC'];
        Train_scores_av(:,r) = Train_scores_av(:,r) + y2; 
		Prog_scores = [Prog_scores' y4]';

%Train_error(times) = length(find(abs(y2-Train_targetC) > 0.05 ));
%Test_error(times) = length(find(abs(y3-Test_targetC) > 0.05));

%[y4' Tt2']
end

%Group1 = [1:size(Train_data,2)];
%Group2 = [size(Train_data,2)+1:size(Train_data,2)+size(Test_data,2)];

%figure
%plot(Group1,Train_targetC,'o', Group1,y2,'*')  
%xlabel('Input order')
%ylabel('Actual (o) and Predicted (*) Target Values')
%title('Blue-Training, Red-Testing')
%hold on
%plot(Group2,Test_targetC,'ro',Group2,y3,'r*')

%Train_error
%TrainPerf = 100-100*(sum(Train_error)/(1*1))/N1
%Test_error
%TestPerf = 100-100*sum(Test_error)/(1*N2)
%Test_scores;

%Y = Test_scores(:,1);
%Yn = Y(1:2:2*N2);
%Ya = Y(2:2:2*N2);
%Yn = y3';
%Ya = Test_targetC';
%N = length(Yn);
%Yn = (max(To)-min(To))*(Yn-0.1)/0.8 + min(To);
%Ya = (max(To)-min(To))*(Ya-0.1)/0.8 + min(To);
%[Yn Ya]

%C = corrcoef(Yn,Ya);
%R2 = C(1,2)^2

%SEP = (100/mean(Ya))*sqrt((Yn-Ya)'*(Yn-Ya)/N


%Take mean of predictions over CV runs

L2 = length(Tt2);
M = zeros(L2,2);
Mtg = zeros(L2,2);
Mtd = zeros(L2,2);
Mtg2 = zeros(L2,2);
Mtd2 = zeros(L2,2);
Mtrg = zeros(L2,2);
Mtrg2 = zeros(L2,2);
gc = zeros(L2,1);
rgc = zeros(L2,1);
dc = zeros(L2,1);

for i=1:max_times
 k = Prog_scores(1+(i-1)*L2:L2*i,:);
 M = M+k;
end
M = M/max_times;

Prog_scoresB = [Prog_scoresB' M]';

end

%Take mean of predictions over 20x18 CV runs

Prog_scoresB = Prog_scoresB';
Mt = zeros(L2,2);
for i=1:max_runs
 k = Prog_scoresB(:,1+(i-1)*2:2*i);
 for j=1:L2
    if (k(j,1) > 0) & (k(j,2) > 0)
       gc(j) = gc(j) + 1;
       Mtg(j,:) = Mtg(j,:) + k(j,:);
       Mtg2(j,:) = Mtg2(j,:) + k(j,:).^2;
    elseif (k(j,1) < 0) & (k(j,2) < 0)
       dc(j) = dc(j) + 1;
       Mtd(j,:) = Mtd(j,:)+ k(j,:);
       Mtd2(j,:) = Mtd2(j,:)+ k(j,:).^2;
   elseif (k(j,1) < 0) & (k(j,2) > 0)
       rgc(j) = rgc(j) + 1;
       Mtrg(j,:) = Mtrg(j,:)+ k(j,:);
       Mtrg2(j,:) = Mtrg2(j,:)+ k(j,:).^2;
    end  
 end 
 Mt = Mt+k;
end
Mt = Mt/max_runs

%Mtg = [Mtg(:,1)./gc Mtg(:,2)./gc]/max_runs
%Mtd =[Mtd(:,1)./dc Mtd(:,2)./dc]/max_runs 

%C = corrcoef(Mt, Tt2);
%Corr = C(1,2)^2

Train_scores_av = Train_scores_av/max_runs

save Mt_grd Mt Mtg Mtd Mtg2 Mtd2 Mtrg Mtrg2 Train_scores T Train_scores_av gc dc rgc InputWB HidenWB InputWB2 HidenWB2